Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionTreeNode.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionTreeNode.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionTreeNode.cs	(revision 18220)
@@ -0,0 +1,43 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("05130B5F-0125-4367-A4E9-C42D1085024E")]
+  public sealed class SubFunctionTreeNode : SymbolicExpressionTreeNode {
+
+    #region Properties
+    public new SubFunctionSymbol Symbol => (SubFunctionSymbol)base.Symbol;
+
+    [Storable]
+    public IEnumerable<string> Arguments { get; set; } = Enumerable.Empty<string>();
+    
+    [Storable]
+    public string Name { get; set; }
+    #endregion
+
+    #region Constructors
+    public SubFunctionTreeNode(SubFunctionSymbol symbol) : base(symbol) { }
+
+    [StorableConstructor]
+    private SubFunctionTreeNode(StorableConstructorFlag _) : base(_) { }
+
+    private SubFunctionTreeNode(SubFunctionTreeNode original, Cloner cloner) : base(original, cloner) {
+      Arguments = original.Arguments;
+      Name = (string)original.Name.Clone();
+    }
+    #endregion
+
+    #region Cloning
+    public override IDeepCloneable Clone(Cloner cloner) => new SubFunctionTreeNode(this, cloner);
+    #endregion
+
+    public override string ToString() {
+      if (string.IsNullOrEmpty(Name))
+        return base.ToString();
+      return $"{Name}({string.Join(",", Arguments)})";
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs	(revision 18220)
@@ -22,8 +22,6 @@
 using System;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  [StorableType("eabf848e-d10c-499e-8c48-c771232ede0e")]
   // this comparer considers that a < b if the type of a is "greater" than the type of b, for example:
   // - A function node is "greater" than a terminal node
Index: trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs
===================================================================
--- trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs	(revision 18220)
@@ -21,5 +21,4 @@
 
 using System.Collections.Generic;
-using System.Linq;
 using HEAL.Attic;
 using HeuristicLab.Common;
@@ -66,5 +65,7 @@
       number.MinValue = -20;
       number.MaxValue = 20;
-      var constant = new Constant();
+      var constant = new Constant() { Enabled = false };
+
+
       variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
 
@@ -89,5 +90,5 @@
       SetSubtreeCount(@if, 3, 3);
       SetSubtreeCount(number, 0, 0);
-      SetSubtreeCount(constant,0, 0);
+      SetSubtreeCount(constant, 0, 0);
       SetSubtreeCount(variableSymbol, 0, 0);
 
@@ -104,6 +105,4 @@
           }
       }
-
-      Symbols.First(s => s is Constant).Enabled = false;
     }
   }
Index: trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs	(revision 18220)
@@ -58,5 +58,7 @@
       StringBuilder strBuilder = new StringBuilder();
       if (Indent) strBuilder.Append(' ', indentLength);
-      if (node.Subtrees.Any()) { // internal node
+      if(node.Symbol is SubFunctionSymbol) {
+        return FormatRecursively(node.GetSubtree(0), indentLength);
+      } else if (node.Subtrees.Any()) { // internal node
         strBuilder.Append("(");
         if (node.Symbol is Addition) {
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 18211)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 18220)
@@ -299,4 +299,5 @@
     <Compile Include="Regression\Physics\PhysicsInstanceProvider.cs" />
     <Compile Include="Regression\Physics\RocketFuelFlow.cs" />
+    <Compile Include="Regression\Physics\SheetBendingProcess.cs" />
     <Compile Include="Regression\VariableNetworks\LinearVariableNetwork.cs" />
     <Compile Include="Regression\VariableNetworks\GaussianProcessVariableNetwork.cs" />
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs	(revision 18220)
@@ -51,5 +51,6 @@
          new AircraftLift(rand.Next()),
          new FluidDynamics(rand.Next()),
-         new AircraftMaximumLift(rand.Next())
+         new AircraftMaximumLift(rand.Next()),
+         new SheetBendingProcess(rand.Next())
       };
     }
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/SheetBendingProcess.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/SheetBendingProcess.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/SheetBendingProcess.cs	(revision 18220)
@@ -0,0 +1,73 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public sealed class SheetBendingProcess : ArtificialRegressionDataDescriptor {
+    public override string Name => "Sheet Bending Process F = E/(E+h) * ((σ_y * t^2) / w + (h * t^3) / (3 * R * w) - (4 * σ_y^3 * R^2) / (3 * w * E^2)) * (1 + 4 * t / w)";
+
+    public override string Description => 
+      "A full description of this instance is given in: " + Environment.NewLine +
+      "Mohammad Zhian Asadzadeh, Hans-Peter Gänser, Manfred Mücke, " + Environment.NewLine +
+      "\"Symbolic regression based hybrid semiparametric modelling of processes: " + Environment.NewLine +
+      "An example case of a bending process\"," + Environment.NewLine +
+      "Applications in Engineering Science, Volume 6, 2021, 100049, " + Environment.NewLine +
+      "ISSN 2666-4968, https://doi.org/10.1016/j.apples.2021.100049. " + Environment.NewLine +
+      "Function: F = E/(E+h) * ((σ_y * t^2) / w + (h * t^3) / (3 * R * w) - (4 * σ_y^3 * R^2) / (3 * w * E^2)) * (1 + 4 * t / w)" +
+      "with E = 210000," + Environment.NewLine +
+      "h ∈ [0.1, 5] [MPa]," + Environment.NewLine +
+      "σ_y ∈ [250, 1000] [MPa]," + Environment.NewLine +
+      "t ∈ [0.5, 5] [mm]," + Environment.NewLine +
+      "R/t ∈ [1, 100]," + Environment.NewLine +
+      "w/R ∈ [0.5, 1.5]";
+
+   
+
+    protected override string TargetVariable => "F";
+    protected override string[] VariableNames => new string[] { "h", "sigma_y", "t", "Rt", "wR", "F" };
+    protected override string[] AllowedInputVariables => new string[] { "h", "sigma_y", "t", "Rt", "wR" };
+
+    protected override int TrainingPartitionStart => 0;
+    protected override int TrainingPartitionEnd => 500;
+    protected override int TestPartitionStart => 500;
+    protected override int TestPartitionEnd => 1000;
+
+    public int Seed { get; }
+
+    public SheetBendingProcess() : this((int)DateTime.Now.Ticks) { }
+
+    public SheetBendingProcess(int seed) {
+      Seed = seed;
+    }
+
+    protected override List<List<double>> GenerateValues() {
+      var rand = new MersenneTwister((uint)Seed);
+
+      List<double> h = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 0.1, 5).ToList();
+      List<double> sigmaY = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 250, 1000).ToList();
+      List<double> t = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 0.5, 5).ToList();
+      List<double> Rt = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 100).ToList();
+      List<double> wR = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 0.5, 1.5).ToList();
+      List<double> F = new List<double>();
+
+      for (int i = TrainingPartitionStart; i < TestPartitionEnd; ++i) {
+        F.Add(Calc(h[i], sigmaY[i], t[i], Rt[i], wR[i]));
+      }
+
+      return new List<List<double>> { h, sigmaY, t, Rt, wR, F };
+    }
+
+    private static double Calc(double h, double sigmaY, double t, double Rt, double wR) {
+      var E = 210000;
+      var R = Rt * t;
+      var w = wR * R;
+      var e = E / (E + h);
+      var yieldStrength = (sigmaY * (t * t)) / w;
+      var plasticHardening = (h * t * t * t) / (3 * R * w);
+      var elasticity = (4 * sigmaY * sigmaY * sigmaY * R * R) / (3 * w * E * E);
+      var C = 1 + 4 * (t / w);
+      return e * (yieldStrength + plasticHardening - elasticity) * C;
+    }
+  }
+}
Index: trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/StructureTemplateRegressionSampleTest.cs
===================================================================
--- trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/StructureTemplateRegressionSampleTest.cs	(revision 18220)
+++ trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/StructureTemplateRegressionSampleTest.cs	(revision 18220)
@@ -0,0 +1,86 @@
+﻿using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HEAL.Attic;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Problems.Instances.DataAnalysis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Selection;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Tests {
+  [TestClass]
+  public class StructureTemplateRegressionSampleTest {
+    private const string SampleFileName = "GP_Structure_Template_Regression";
+    private static readonly ProtoBufSerializer serializer = new ProtoBufSerializer();
+
+    [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
+    public void RunStructureTemplateRegressionSampleTest() {
+      var ga = CreateStructureTemplateRegressionSample();
+      ga.SetSeedRandomly.Value = false;
+      SamplesUtils.RunAlgorithm(ga);
+
+      if (Environment.Is64BitProcess) {
+        Assert.AreEqual(5.0286947997733353E-07, SamplesUtils.GetDoubleResult(ga, "BestQuality"), 1E-8);
+        Assert.AreEqual(79.100605440090362, SamplesUtils.GetDoubleResult(ga, "CurrentAverageQuality"), 1E-8);
+        Assert.AreEqual(7905.465554758197, SamplesUtils.GetDoubleResult(ga, "CurrentWorstQuality"), 1E-8);
+        Assert.AreEqual(5050, SamplesUtils.GetIntResult(ga, "EvaluatedSolutions"));
+      } else {
+        Assert.AreEqual(5.45285034915826E-07, SamplesUtils.GetDoubleResult(ga, "BestQuality"), 1E-8);
+        Assert.AreEqual(0.25447047591366467, SamplesUtils.GetDoubleResult(ga, "CurrentAverageQuality"), 1E-8);
+        Assert.AreEqual(23.211139545787372, SamplesUtils.GetDoubleResult(ga, "CurrentWorstQuality"), 1E-8);
+        Assert.AreEqual(5050, SamplesUtils.GetIntResult(ga, "EvaluatedSolutions"));
+      }
+    }
+
+    [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
+    public void CreateStructureTemplateRegressionSampleTest() {
+      var ga = CreateStructureTemplateRegressionSample();
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      serializer.Serialize(ga, path);
+    }
+
+    public static GeneticAlgorithm CreateStructureTemplateRegressionSample() {
+      var alg = new GeneticAlgorithm();
+      var provider = new PhysicsInstanceProvider(seed: 0);
+      var descriptor = new SheetBendingProcess(seed: 0);
+      var problem = new StructureTemplateSymbolicRegressionProblem();
+      problem.Load(provider.LoadData(descriptor));
+      problem.StructureTemplate.Template =
+        "(" +
+          "(210000 / (210000 + h)) * ((sigma_y * t * t) / (wR * Rt * t)) + " +
+          "PlasticHardening(_) - Elasticity(_)" +
+        ")" +
+        " * C(_)";
+      foreach(var subFunction in problem.StructureTemplate.SubFunctions) {
+        subFunction.MaximumSymbolicExpressionTreeDepth = 8;
+        subFunction.MaximumSymbolicExpressionTreeLength = 20;
+        subFunction.Grammar = new ArithmeticExpressionGrammar();
+      }
+
+      #region Algorithm Configuration
+      alg.Name = "Genetic Programming - Structure Template";
+      alg.Description = "A standard genetic programming algorithm to solve a regression problem with a predefined structure template (Sheet Bending Process)";
+      alg.Problem = problem;
+
+      SamplesUtils.ConfigureGeneticAlgorithmParameters<TournamentSelector, MultiEncodingCrossover, MultiEncodingManipulator>
+        (alg, popSize: 100, elites: 1, maxGens: 50, mutationRate: 0.25, tournGroupSize: 3);
+
+      alg.Seed.Value = 0;
+      alg.Engine = new ParallelEngine.ParallelEngine();
+      #endregion
+
+      return alg;
+    }
+  }
+}
Index: trunk/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- trunk/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 18211)
+++ trunk/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 18220)
@@ -471,4 +471,5 @@
     <Compile Include="HeuristicLab-3.3\Samples\GAGroupingProblemSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\ShapeConstrainedRegressionSampleTest.cs" />
+    <Compile Include="HeuristicLab-3.3\Samples\StructureTemplateRegressionSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\VnsOpSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\EsGriewankSampleTest.cs" />
